/*
  File autogenerated by gengetopt version 2.12.2
  generated with the following command:
  gengetopt --input=volmakecmap_cmd.ggo --file-name=volmakecmap_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "volmakecmap_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

struct zero_list
{
  int zero_arg;
  struct zero_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->out_given = 0 ;
  args_info->cpt_given = 0 ;
  args_info->zero_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0 ;
  args_info->out_arg = NULL;
  args_info->cpt_arg = NULL;
  args_info->zero_arg = NULL;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
"  Make color maps/color transfer functions for SimVoleon OpenInventor files.\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help              Print help and exit");
  printf("%s\n","  -V, --version           Print version and exit");
  printf("%s\n","  -v, --verbosity=INT     Set the verbosity level (0=quiet 10=verbose \n                            20=bombastic)  (default=`0')");
  printf("%s\n","  -o, --out=filename      Ouput the cmap model here");
  printf("%s\n","  -c, --cpt=cpt_filename  Use a GMT style Color Pallet Table");
  printf("%s\n","  -z, --zero=index        Zero out a color table entry [0..255].  Makes it \n                            transparent");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->out_arg)
    {
      free (args_info->out_arg); /* free previous argument */
      args_info->out_arg = 0;
    }
  if (args_info->cpt_arg)
    {
      free (args_info->cpt_arg); /* free previous argument */
      args_info->cpt_arg = 0;
    }
  if (args_info->zero_arg)
    {
      free (args_info->zero_arg); /* free previous argument */
      args_info->zero_arg = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  int len;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  if (tok)
    len = (tok - arg + 1);
  else
    len = strlen (arg) + 1;

  ret = (char *) malloc (len);
  strncpy (ret, arg, len-1);
  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */

  int i;        /* Counter */

  struct zero_list * zero_list = NULL,* zero_new = NULL;
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "out",	1, NULL, 'o' },
        { "cpt",	1, NULL, 'c' },
        { "zero",	1, NULL, 'z' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:o:c:z:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg,&stop_char,0);
          break;

        case 'o':	/* Ouput the cmap model here.  */
          if (local_args_info.out_given)
            {
              fprintf (stderr, "%s: `--out' (`-o') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->out_given && ! override)
            continue;
          local_args_info.out_given = 1;
          args_info->out_given = 1;
          if (args_info->out_arg)
            free (args_info->out_arg); /* free previous string */
          args_info->out_arg = gengetopt_strdup (optarg);
          break;

        case 'c':	/* Use a GMT style Color Pallet Table.  */
          if (local_args_info.cpt_given)
            {
              fprintf (stderr, "%s: `--cpt' (`-c') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->cpt_given && ! override)
            continue;
          local_args_info.cpt_given = 1;
          args_info->cpt_given = 1;
          if (args_info->cpt_arg)
            free (args_info->cpt_arg); /* free previous string */
          args_info->cpt_arg = gengetopt_strdup (optarg);
          break;

        case 'z':	/* Zero out a color table entry [0..255].  Makes it transparent.  */
          local_args_info.zero_given++;
          multi_token = get_multiple_arg_token(optarg);
          multi_next = get_multiple_arg_token_next (optarg);
          
          while (1)
            {
              zero_new = (struct zero_list *) malloc (sizeof (struct zero_list));
              zero_new->next = zero_list;
              zero_list = zero_new;
              zero_new->zero_arg = strtol (multi_token,&stop_char,0);
          
              if (multi_next)
                {
                  multi_token = get_multiple_arg_token(multi_next);
                  multi_next = get_multiple_arg_token_next (multi_next);
                  local_args_info.zero_given++;
                }
              else
                break;
            }
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.zero_given && zero_list)
    {
      struct zero_list *tmp;
      args_info->zero_arg = (int *) realloc (args_info->zero_arg, (args_info->zero_given + local_args_info.zero_given) * sizeof (int));
      for (i = (local_args_info.zero_given - 1); i >= 0; --i)
        {
          tmp = zero_list;
          args_info->zero_arg [i + args_info->zero_given] = zero_list->zero_arg;
          zero_list = zero_list->next;
          free (tmp);
        }
    }
  

  args_info->zero_given += local_args_info.zero_given;
  
  if (check_required)
    {
      if (! args_info->out_given)
        {
          fprintf (stderr, "%s: '--out' ('-o') option required%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
          error = 1;
        }
    }

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  return (EXIT_FAILURE);
}
